#include <windows.h>
#include <aygshell.h>
#include <fstream>
#include <string>
#include <Pm.h>
#include <Pmpolicy.h>

using namespace std;

static HANDLE* lpvMem = NULL;      // pointer to shared memory
static HANDLE hMapObject = NULL;  // handle to sharedMemory

unsigned long __cdecl mainProc(LPVOID params){
	Sleep(2000);//wait for other components to load...
	HKEY myKey;
	DWORD disposition;
	DWORD sizeValue;
	unsigned char action;

	BYTE  buffer[sizeof(POWER_BROADCAST) + sizeof(POWER_BROADCAST_POWER_INFO)];
	DWORD dwRead;
	DWORD dwFlags;
	SYSTEMTIME time;
	bool wasON=true;
	bool isON=true;
	DWORD timeDWORD;

	RegCreateKeyEx(HKEY_LOCAL_MACHINE, L"SOFTWARE\\Manila_QuickShutdown", 0, 0, REG_OPTION_NON_VOLATILE,
		KEY_ALL_ACCESS, 0, &myKey, &disposition);

	GetLocalTime(&time);
	timeDWORD=time.wHour*3600+time.wMinute*60+time.wSecond;
	dwFlags=0x00010000;
	RegSetValueEx(myKey,L"timeState",0,REG_DWORD,(const BYTE*)&timeDWORD,sizeof(DWORD));
	RegSetValueEx(myKey,L"StateFlag",0,REG_DWORD,(const BYTE*)&dwFlags,sizeof(DWORD));

	RegCloseKey(myKey);

	Sleep(3000);//wait for other components to load...


	MSGQUEUEOPTIONS msgQueOpt;
	ZeroMemory(&msgQueOpt,sizeof(msgQueOpt));
	msgQueOpt.dwSize = sizeof(msgQueOpt);
	msgQueOpt.dwFlags = MSGQUEUE_NOPRECOMMIT;
	msgQueOpt.dwMaxMessages = 32;
	msgQueOpt.cbMaxMessage = 4096;
	msgQueOpt.bReadAccess = TRUE;

	HANDLE hPowerMsgQ = CreateMsgQueue(_T("PowerMsgQ"), &msgQueOpt);

	lpvMem[1]=RequestPowerNotifications(hPowerMsgQ,PBT_TRANSITION|PBT_RESUME);

	while(lpvMem[1]!=NULL){//until the device is turn off...

		if(ReadMsgQueue(hPowerMsgQ, (LPVOID)buffer, sizeof(buffer), &dwRead, 
			INFINITE, &dwFlags))
		{
			POWER_BROADCAST* pPower = (POWER_BROADCAST*)buffer;
			if(pPower!=NULL){

				RegCreateKeyEx(HKEY_LOCAL_MACHINE, L"SOFTWARE\\Manila_QuickShutdown", 0, 0, REG_OPTION_NON_VOLATILE,
					KEY_ALL_ACCESS, 0, &myKey, &disposition);

				bool isON=(pPower->Flags&POWER_STATE_ON)!=0;
				if(wasON!=isON&&pPower->Flags!=0){

					sizeValue=sizeof(unsigned char);
					if(RegQueryValueEx(myKey,L"shouldLock", 0, 0, (LPBYTE)&action, &sizeValue)!=ERROR_SUCCESS)
						action=0;

					if(action!=0){//lockDevice
						keybd_event(VK_F22, 0, KEYEVENTF_SILENT, 0);
						Sleep(50);
						keybd_event(VK_F22, 0, KEYEVENTF_KEYUP, 0);
					}
				}
				GetLocalTime(&time);
				timeDWORD=time.wHour*3600+time.wMinute*60+time.wSecond;
				RegSetValueEx(myKey,L"timeState",0,REG_DWORD,(const BYTE*)&timeDWORD,sizeof(DWORD));
				RegSetValueEx(myKey,L"StateFlag",0,REG_DWORD,(const BYTE*)&pPower->Flags,sizeof(DWORD));

				RegCloseKey(myKey);
				wasON=isON;
			}
		}
	}
	return 0;
}

BOOL APIENTRY DllMain(
					  HANDLE hModule, 
					  DWORD  ul_reason_for_call, 
					  LPVOID lpReserved
					  )
{
	BOOL fInit, fIgnore;
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:

		// Create a named file mapping object

		hMapObject = CreateFileMapping( 
			INVALID_HANDLE_VALUE,   // use paging file
			NULL,                   // default security attributes
			PAGE_READWRITE,         // read/write access
			0,                      // size: high 32-bits
			sizeof(HANDLE),              // size: low 32-bits
			TEXT("globalValuesMapProcess")); // name of map object
		if (hMapObject == NULL) 
			return TRUE;//silently fall

		// The first process to attach initializes memory
		fInit = (GetLastError() != ERROR_ALREADY_EXISTS);

		// Get a pointer to the file-mapped shared memory
		lpvMem = (HANDLE*)MapViewOfFile(
			hMapObject,     // object to map view of
			FILE_MAP_WRITE, // read/write access
			0,              // high offset:  map from
			0,              // low offset:   beginning
			0);             // default: map entire file
		if (lpvMem == NULL){
			hMapObject = NULL;
			return TRUE;//silently fall
		}

		// Initialize memory if this is the first process
		if (fInit){
			memset(lpvMem, NULL, sizeof(HANDLE)*2);
		}

		break; 
		// The attached process creates a new thread
	case DLL_THREAD_ATTACH: 
		break;
		// The thread of the attached process terminates
	case DLL_THREAD_DETACH: 
		break;
		// DLL unload due to process termination or FreeLibrary
	case DLL_PROCESS_DETACH: 
		// Unmap shared memory from the process's address space
		fIgnore = UnmapViewOfFile(lpvMem);
		// Close the process's handle to the file-mapping object
		fIgnore = CloseHandle(hMapObject);
		break; 

	default: 
		break;
	}

	return TRUE;
}


DWORD HPN_Close(DWORD dwData)
{
	if(lpvMem!=NULL&&lpvMem[0]!=NULL){
		StopPowerNotifications(lpvMem[1]);
		lpvMem[1]=NULL;
		TerminateThread(lpvMem[0],0);
		lpvMem[0]=NULL;
	}
	return 1;
}

DWORD HPN_Deinit(DWORD dwData)
{
	return 1;
}

DWORD HPN_Init(DWORD dwData)
{
	if(lpvMem!=NULL&&lpvMem[0]==NULL)
		lpvMem[0]=CreateThread(NULL,NULL,mainProc,NULL,NULL,NULL);
	return 1;
}

DWORD HPN_IOControl(DWORD dwData,DWORD dwCode,PBYTE pBufIn,DWORD dwLenIn,PBYTE pBufOut,DWORD dwLenOut,PDWORD pdwActualOut)
{
	return 1;
}

DWORD HPN_Open(DWORD dwData,DWORD dwAccess,DWORD dwShareMode)
{
	return 0;
}

DWORD HPN_Read(DWORD dwData,LPVOID pBuf,DWORD dwLen)
{
	return 0;
}

DWORD HPN_Seek(DWORD dwData,long pos,DWORD type)
{
	return 0;
}

DWORD HPN_Write(DWORD dwData,LPCVOID pInBuf,DWORD dwInLen)
{
	return 0;
}


