#pragma once
#include "sdk_manila_sense.h"
#include "textfile.h"

class ConfigQS :
	public EventHandler
{
	static bool isWarned;
protected:
	//function to init application (add item to our window, init var, etc.)
	void initApplication();
	//function which is called when event appends
	void messageTreatment(Element* src,int idEvent,void* lParam=NULL);

	vector<wstring> vectLangFiles;
	unsigned char nbLangFiles;
	wstring langDir;
	wstring localShutdown;
	wstring localReset;
	wstring localSleep;
	wstring localCancel;
	wstring langChoose;
	wstring langSave;
	wstring langTurnOff;
	wstring langBoot;
	wstring langProg;
	wstring titlePanelProg;
	wstring langShortPress[5];
	wstring shouldLock;
	wstring msgWarning;
	wstring langHR;
	bool loadInfo(wstring textFile,bool skipVerif=false);
	bool saveInfo(wstring textFile);
public:
	ConfigQS(HINSTANCE hInstance);
	~ConfigQS(void);
};